'=================================================
'Language Writer
'=================================================
Rem
	Incompatible with:
		1.0 (no german letters)
		1.01 (no german letters)
		1.02 (no german letters)
	
	Compatible with:
		1.03
		1.04
		1.05
End Rem
'=================================================

SuperStrict

Framework BRL.Stream
	Import BRL.LinkedList

'=================================================

Local LangList:TList = New TList

'=================================================
'WARNING: DONT USE SPECIAL LETTERS LIKE QUESTION MARKS!!!
'WARNING: PROGRAMM WILL FILTER INVALID WORDS!!!
'=================================================
'WORDS HERE ...
'=================================================

'Basic
LangList.AddLast("Kernle32DLL")
LangList.AddLast("BMAX") LangList.AddLast("BlitzMax")
LangList.AddLast("B3D") LangList.AddLast("Blitz3D")
LangList.AddLast("BB") LangList.AddLast("BlitzBasic")
LangList.AddLast("Irrlicht")

'BBP
LangList.AddLast("BBP") LangList.AddLast("BlitzBasicPortal")
LangList.AddLast("BCC") LangList.AddLast("BlitzCodeCompo")
LangList.AddLast("BAC") LangList.AddLast("BlitzArtCompo")
LangList.AddLast("Portal")
LangList.AddLast("Worklog")
LangList.AddLast("Thread")
LangList.AddLast("Post")

LangList.AddLast("Idee")		'1
LangList.AddLast("Frage")		'2
LangList.AddLast("Antwort")	'3
LangList.AddLast("Trash")		'4
LangList.AddLast("Noob")		'5

'Programmieren
LangList.AddLast("Android")
LangList.AddLast("Display")
LangList.AddLast("Programmierer")
LangList.AddLast("Animation")
LangList.AddLast("3DModell")
LangList.AddLast("AND") LangList.AddLast("NAND")
LangList.AddLast("OR") LangList.AddLast("NOR")
LangList.AddLast("XOR")

'Websiten
LangList.AddLast("Wikipedia")
LangList.AddLast("Google")
LangList.AddLast("GMX")
LangList.AddLast("Yahoo")
LangList.AddLast("Amazon")

'Beschreibungen
LangList.AddLast("Gegenteil")
LangList.AddLast("Strafverfahren")	
LangList.AddLast("Gerechtigkeit")
LangList.AddLast("Entschuldigung")
LangList.AddLast("Blasphemie")
LangList.AddLast("Kryptisch")

'Gegenstnde
LangList.AddLast("Etikette")
LangList.AddLast("Genehmigung")
LangList.AddLast("Vertrag")
LangList.AddLast("Weihnachten")
LangList.AddLast("Tannenbaum")
LangList.AddLast("Gral")
LangList.AddLast("Pflanze")
LangList.AddLast("Geld")
LangList.AddLast("Keks")
LangList.AddLast("Knopf")
LangList.AddLast("Topf")
LangList.AddLast("Teppich")
LangList.AddLast("Eimer")

'Getrnke
LangList.AddLast("Gesundheit")
LangList.AddLast("Flasche")
LangList.AddLast("Bier")
LangList.AddLast("Schnaps")
LangList.AddLast("Wein")

'Krieg
LangList.AddLast("Ernst")
LangList.AddLast("Sieg")
LangList.AddLast("Panzer")
LangList.AddLast("Panzerfaust")
LangList.AddLast("Kraftfahrzeug")
LangList.AddLast("Schweibrenner")
LangList.AddLast("Flammenwerfer")
LangList.AddLast("Terrorist")

'Unsortierter Quatsch
LangList.AddLast("Toilettenabflussreiniger")
LangList.AddLast("Klostein")
LangList.AddLast("Toilette")
LangList.AddLast("Schimmel")
LangList.AddLast("Gullideckel")
LangList.AddLast("Pest")
LangList.AddLast("Exorzist")
LangList.AddLast("Bordell")
LangList.AddLast("Metal")
LangList.AddLast("Hamsterrad")
LangList.AddLast("Zentralverriegelung")

'Filme / Spiele
LangList.AddLast("Anime")
LangList.AddLast("CubeWars")
LangList.AddLast("Dragonball")
LangList.AddLast("DeathNote")
LangList.AddLast("Fuwalafuwalu") 'Suikoden V
LangList.AddLast("Jigsaw")
LangList.AddLast("Jogswa")
LangList.AddLast("Fyu")
LangList.AddLast("Highlander")
LangList.AddLast("Gumba")
LangList.AddLast("Saw")

'Krperteile
LangList.AddLast("Hyperventilieren")
LangList.AddLast("Lunge")
LangList.AddLast("Herz")
LangList.AddLast("Nieren")
LangList.AddLast("Kopf")
LangList.AddLast("Hand")
LangList.AddLast("Augen")

'Orte
LangList.AddLast("Sumpf")
LangList.AddLast("Himmel")
LangList.AddLast("Wolke")
LangList.AddLast("Erde")

'Kleidung
LangList.AddLast("Nietenarmband")
LangList.AddLast("Nietenhalsband")
LangList.AddLast("TShirt")
LangList.AddLast("Hose")
LangList.AddLast("Mantel")
LangList.AddLast("Schuh")
LangList.AddLast("Hemd")
LangList.AddLast("Stiefel")
LangList.AddLast("Springerstiefel")
LangList.AddLast("Armbanduhr")
LangList.AddLast("Haargummi")
LangList.AddLast("Kappe")
LangList.AddLast("Mtze")
LangList.AddLast("Umhang")
LangList.AddLast("Cape")
LangList.AddLast("Kettenhemd")
LangList.AddLast("Rstung")
LangList.AddLast("BH")
LangList.AddLast("Wonderbra")
LangList.AddLast("Korsett")
LangList.AddLast("Bluse")
LangList.AddLast("Bste")
LangList.AddLast("Schweiband")
LangList.AddLast("Brille")

'Tiere
LangList.AddLast("Maulwurf")
LangList.AddLast("Maus")
LangList.AddLast("Fisch")
LangList.AddLast("Katze")
LangList.AddLast("Hund")
LangList.AddLast("Hamster")
LangList.AddLast("Rollmops")
LangList.AddLast("Ente")
LangList.AddLast("Gans")
LangList.AddLast("Hahn")
LangList.AddLast("Schwein")
LangList.AddLast("Kuh")
LangList.AddLast("Bulle")
LangList.AddLast("Insekt")
LangList.AddLast("Mcke")
LangList.AddLast("Elephant")
LangList.AddLast("Motte")
LangList.AddLast("Schildkrte")
LangList.AddLast("Heuschrecke")

'Chat Kram
LangList.AddLast("ICQ")
LangList.AddLast("MSN")
LangList.AddLast("Skype")
LangList.AddLast("Miranda")
LangList.AddLast("ICQ2GO")

'Chat Abkrzungen (irgendwie alle doof)
'LangList.AddLast("1337")
'LangList.AddLast("h44x")
'LangList.AddLast("rofl")	'rolling on floor laughing
'LangList.AddLast("lol")	'lauthing out loud
'LangList.AddLast("idc")	'i dont care	
'LangList.AddLast("idk")	'i dont know
'LangList.AddLast("imo")	'in my opinion

'=================================================
'WORDS END
'=================================================

Local FileStream:TStream = WriteStream("Language.txt")

Local Counter:Int
Local AvgLength:Int

If FileStream
	For Local str:String = EachIn LangList
		Local ContainMode:Byte = StringContains(str)
		If ContainMode & 8 Or ContainMode & 16 Then Continue
		
		WriteInt(FileStream,str.length)
		WriteString(FileStream,str)
		
		Counter:+1
		AvgLength:+str.length
	Next
	CloseStream FileStream
	DebugLog Counter + " words saved!"
	DebugLog "Average length is ~~" + AvgLength/Counter + " letters!"
Else
	DebugLog "Cant write file!"
EndIf

'=================================================

Function NumBewteen:Byte(num:Int,minnum:Int = 0,maxnum:Int = 10)
	If num >= minnum And num <= maxnum Then Return True Else Return False
End Function

Function StringContains:Byte(SearchString:String)
	Const LETTERS:Byte = 1
	Const UPPERLETTERS:Byte = 2
	Const NUMBERS:Byte = 4
	Const SPECIALCHARS:Byte = 8
	Const CONTROLCHARS:Byte = 16
	Const GERMANCHARS:Byte = 32
	Const SPACECHAR:Byte = 64
	
	Local Mode:Int = 0
	
	For Local I:Int = 0 To SearchString.length-1
		Local CharID:Int = SearchString[I]
		If (Not (Mode & LETTERS)) And NumBewteen(CharID,97,122) Then Mode:+LETTERS
		If (Not (Mode & UPPERLETTERS)) And NumBewteen(CharID,65,90) Then Mode:+UPPERLETTERS
		If (Not (Mode & NUMBERS)) And NumBewteen(CharID,48,57) Then Mode:+NUMBERS
		If (Not (Mode & SPECIALCHARS)) And (NumBewteen(CharID,33,47) Or NumBewteen(CharID,58,64) Or NumBewteen(CharID,91,96) Or CharID > 122) And Not (CharID = 196 Or CharID = 228 Or CharID = 214 Or CharID = 246 Or CharID = 220 Or CharID = 252 Or CharID = 223) Then Mode:+SPECIALCHARS
		If (Not (Mode & CONTROLCHARS)) And NumBewteen(CharID,0,31) Then Mode:+CONTROLCHARS
		If (Not (Mode & GERMANCHARS)) And (CharID = 196 Or CharID = 228 Or CharID = 214 Or CharID = 246 Or CharID = 220 Or CharID = 252 Or CharID = 223) Then Mode:+GERMANCHARS
		If (Not (Mode & SPACECHAR)) And CharID = 32 Then Mode:+SPACECHAR
		
		If Mode = 127 Then Return Mode
	Next
	
	Return Mode
End Function