;====================================================================
; Project: Terme
; Version: 1.0
; Author: Count-Doku
; Email: jannis96@googlemail.com
; Copyright: Count-Doku   7.5.2010 - 8.5.2010
; Description:    Calculate the 5 terms in 60 seconds.
;====================================================================
Graphics 800,300,0,2
SetBuffer BackBuffer()
.start
ClsColor 0,0,0
Color 248,248,248
Cls
FlushKeys
SetFont LoadFont("Arial",30,0,0,1)
Text 400,1,"Wilkommen bei Speed Term!!",1
SetFont LoadFont("Verdana",20)
Text 400,50,"Lse den Term nach x auf.",1
Text 400,70,"Dafr hast du fr 5 Terme 60Sekunden...",1
Text 400,90,"Viel Glck!",1
Text 400,120,"<Taste drcken>",1
WaitKey
Local timer=CreateTimer(20)
Local startTime=MilliSecs()
Local akt_time=MilliSecs()
Local lastclear
Global lvl=1
Dim Loesungen$(1)
LoesungenLaden()
FlushKeys
ClsColor 248,248,248
Color 0,0,0
While Not KeyHit(1)
	Cls
	Select lvl
		Case 1;leichte
			Text 10,10,"Lse diesen Term: 4*5=x"
			Text 10,25,"Lsung: x="+txt$
			txt$=NewInput(txt$)
		Case 2
			Text 10,10,"Lse diesen Term: 8=x+4"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 3
			Text 10,10,"Lse diesen Term: 2^2=2*x"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 4
			Text 10,10,"Lse diesen Term: 2*x=3+4"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 5
			Text 10,10,"Lse diesen Term: 6/2=x*2"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 6;Mittlere
			Text 10,10,"Lse diesen Term: 4*x/2=4*x-10"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 7
			Text 10,10,"Lse diesen Term: (x-10)*2=x-5"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 8
			Text 10,10,"Lse diesen Term: 8^2+x=55/0,5-47-x"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 9
			Text 10,10,"Lse diesen Term: 9-x=2*x-9*2"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 10
			Text 10,10,"Lse diesen Term: 0,33+x=0,99"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 11;Mittlere mit Klammern
			Text 10,10,"Lse diesen Term: 6*(x-3)-3*x=12"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 12
			Text 10,10,"Lse diesen Term: 2*x-8*(x+12)=54-18*x"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 13
			Text 10,10,"Lse diesen Term: (15*x-5)/(-5)=(-14*x-2)/0,5"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 14
			Text 10,10,"Lse diesen Term: 2*x-3*(1+0.66*x)=(-2)"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 15
			Text 10,10,"Lse diesen Term: 5*(x-7)-4x=11"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 16;Schwere
			Text 10,10,"Lse diesen Term: (x-4)*(x+5)=x^2-17"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 17
			Text 10,10,"Lse diesen Term: (9-x)*(4+x)=45-x^2"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 18
			Text 10,10,"Lse diesen Term: (x+3)*(2x-2)=(2x-1)*(x+5)+4"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 19
			Text 10,10,"Lse diesen Term: (3-x)*(5-x)=3-2x+x^2"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 20
			Text 10,10,"Lse diesen Term: (x-4)*(x+5)-(x-1)*(x+1)=1"
			Text 10,25,"Lsung: x="+txt
			txt=NewInput(txt)
		Case 21
			Text 10,10,"MASTER-FRAGE!!!
			Text 10,25,"Term: x=1+1"
			Text 10,40,"Lsung: x="+txt
			txt=NewInput(txt)
	End Select
	If KeyHit(28)
		txt$=Replace(txt$,".",",")
		If txt$=Loesungen$(lvl)
			If (lvl Mod 5)=0
				Text 10,80,"Level geschafft!"
				Flip
				Delay 2000
				startTime=MilliSecs()
			End If
			lvl=lvl+1
			lastclear=MilliSecs()
		End If
		txt=""
	End If
	If lvl=22
		Ende("GFX\Winner.png")
		Goto start
	End If
	If (akt_time-startTime)/1000>60
		Ende("GFX\Looser.png")
		Goto start
	End If
	If MilliSecs()-lastclear<1500
		Text 10,60,"Richtig!"
	End If
	akt_time=MilliSecs()
	Text 500,10,"Vergangene Zeit: "+(akt_time-startTime)/1000+" Sekunden..."
	Text 500,25,"Verbleibende Zeit: "+(60-((akt_time-startTime)/1000))+" Sekunden..."
	WaitTimer timer
	Flip 0
Wend
End

Function NewInput$(currentText$) 
	localChar = GetKey() 
	If (localChar > 0) And (localChar <> 8 ) And (Localchar<>13) Then 
		currentText$ = currentText$ + Chr$(localChar) 
	ElseIf localChar = 8 Then 
		length = Len(currentText) 
		If length > 0 Then 
			currentText = Left(currentText, length - 1) 
		EndIf 
	EndIf 
	Return currentText$ 
End Function 
Function LoesungenLaden()
	Dim Loesungen$(21)
	;Leichte Aufgaben
	Loesungen(1)="20"
	Loesungen(2)="4"
	Loesungen(3)="2"
	Loesungen(4)="3,5"
	Loesungen(5)="1,5"
	;Mittlere
	Loesungen(6)="5"
	Loesungen(7)="15"
	Loesungen(8)="-0,5"
	Loesungen(9)="9"
	Loesungen(10)="0,66"
	;Mit Klammern
	Loesungen(11)="10"
	Loesungen(12)="12,5"
	Loesungen(13)="-0,2"
	Loesungen(14)="50"
	Loesungen(15)="46"
	;Schwere Aufgaben
	Loesungen(16)="3"
	Loesungen(17)="1,8"
	Loesungen(18)="-1"
	Loesungen(19)="2"
	Loesungen(20)="20"
	;Masterfrage
	Loesungen(21)="2"
End Function
Function Ende(pfad$)
	Cls:Flip
	Cls:Flip
	bild=LoadImage(pfad)
	MidHandle bild
	DrawImage bild,400,150
	Flip
	FlushKeys
	Print("Nochmal spielen? <J/N> ")
	nochmal$=WaitKey()
	nochmal$=Chr(nochmal$)
	nochmal=Upper(nochmal)
	If nochmal=("J")
		lvl=1
	Else
		End
	End If
End Function
;~IDEal Editor Parameters:
;~F#9B#A7#C4
;~C#Blitz3D