SuperStrict
AppTitle = "Mathematischer Kampfmittelrumdienst"
Graphics 800,600
SetMaskColor(0,0,57)
SeedRnd MilliSecs()
HideMouse()
Global Background:TImage = LoadImage("x/bg1.jpg"), Empty_Background:TImage = LoadImage("x/bg2.jpg"), GlobalTimer:TTimer = CreateTimer(60)
'--------------------------------------------------------------------
'============   Funkenfeuer:   ========================
Type Funkenpartikel
   Field x#,y#,way%,r#,start%,time%
End Type
Global Funkenpartikel_Liste:TList=CreateList(), Funken_Bild:TImage = LoadImage("x/fk.png")
SetImageHandle(Funken_Bild, 4, 6)
Function zeige_Funkenfeuer(x:Int, y:Int)
	Local ActualTime% = MilliSecs()
	For Local P:Funkenpartikel = EachIn Funkenpartikel_Liste
		Local part# = 1.0*(ActualTime-P.start) / P.time
		If part < 1 Then
			SetColor 255, 255-part*155, 255-part*155
			Local distance:Float = P.way*part
			SetBlend LIGHTBLEND
			SetAlpha 1-0.5*part
			DrawImage Funken_Bild, P.x + distance*Cos(P.r), P.y + distance*Sin(P.r)
		Else
			P.x = x + Rand(-2,2)
			P.y = y + Rand(-2,2)
			P.way = Rand(20,30)
			P.r = Rnd()*360
			P.start = MilliSecs()
			P.time = Rand(100,300)
		End If
	Next
	SetAlpha 1.0
	SetBlend ALPHABLEND
End Function
'======================================================
Function BildeAufgabenPermutation:Int[](Anzahl:Int)
	Local i:Int, j:Int, Rueckgabe:Int[Anzahl], Memo_Zahl:Int
	Anzahl = Anzahl - 1
	For i = 0 To Anzahl
		Rueckgabe[i] = i
	Next
	For i = Anzahl To 1 Step -1
		Local Zufall:Int = Rand(0,i)
		Memo_Zahl = Rueckgabe[i]
		Rueckgabe[i] = Rueckgabe[Zufall]
		If Zufall < i Then
			For j = Zufall To i - 1
				Rueckgabe[j] = Rueckgabe[j + 1]
			Next
			Rueckgabe[i - 1] = Memo_Zahl
		End If
	Next
	Return Rueckgabe
End Function
'============   Zahlen-Code:   =========================
Global Auswahl:Int[], Aufgabe:String, Losung:Int, Nr:Int, AufgabenPermutation:Int[] = BildeAufgabenPermutation(25), text:String[47], text_file:TStream = ReadFile("x/tx.txt")
For Losung = 0 To 46
	text[Losung] = ReadLine(text_file)
Next
Function neue_Aufgabe()
	'-----------------------------
	Select AufgabenPermutation[Nr]
	Case 0
		Aufgabe = text[0]
		Auswahl = [416, 525, 636, 749, 864, 981]
	Case 1
		Losung = Rand(7,11)
		Aufgabe = text[1] + Losung + "! durch " + (Losung-3) + "! und addiere eine Zufallszahl, die zwischen -3 und +3 liegt."
		Losung = Losung * (Losung-1) * (Losung-2)
		Auswahl = [Losung-3, Losung-2, Losung-1, Losung, Losung+1, Losung+2, Losung+3]
	Case 2
		Aufgabe = text[2]
		Auswahl = [135, 147, 159, 246, 258, 357, 369, 468, 579]
	Case 3
		Aufgabe = text[3]
		Auswahl = [149, 194, 419, 491, 914, 941]
	Case 4
		Aufgabe = text[4]
		Auswahl = [134, 314, 156, 516, 178, 718, 358, 538]
	Case 5
		Local Losung:Int = Rand(11,16), a:Int, b:Int = Rand(3,5)
		Repeat
			a = Rand(3,5)
		Until a <> b
		Aufgabe = text[5] + (Losung*a) + " und " + (Losung*b)
		Losung = Losung * a * b
		If Losung*4 < 1000 Then
			Auswahl = [Losung, Losung*2, Losung*3, Losung*4]
		Else
			Auswahl = [Losung, Losung*2, Losung*3]
		End If
	Case 6
		Aufgabe = text[6]
		Auswahl = [933, 842, 824, 632, 623, 422]
	Case 7
		Aufgabe = text[7]
		Auswahl = [400, 310, 301, 220, 202, 130, 103, 112, 121, 211]
	Case 8
		Aufgabe = text[8]
		Auswahl = [100, 110, 101, 200, 111, 102, 120, 210, 201, 300]
	Case 9
		Aufgabe = text[9]
		Auswahl = [988, 898, 889, 997, 979, 799, 998, 989, 899, 999]
	Case 10
		Aufgabe = text[10]
		Auswahl = [147, 174, 417, 471, 714, 741, 227, 272, 722]
	Case 11
		Aufgabe = text[11]
		Auswahl = [235, 253, 352, 325, 523, 532, 156, 165, 516, 561, 615, 651]
	Case 12
		Aufgabe = text[12]
		Auswahl = [666, 468, 486, 648, 684, 846, 864, 288, 828, 882]
	Case 13
		Aufgabe = text[13]
		Auswahl = [121, 242, 363, 484]
	Case 14
		Aufgabe = text[14]
		Auswahl = [171, 252, 333, 414, 585, 666, 747, 828, 909, 999]
	Case 15
		Local a:String, b:String = String(Rand(1,9))
		Repeat
			a = String(Rand(1,9))
		Until a <> b
		Aufgabe = text[15] + a + " vor, oder die Ziffer " + b + ". Auf jeden Fall aber KEINE ANDERE Ziffer!"
		Auswahl = [Int(a+a+a), Int(a+a+b), Int(a+b+a), Int(b+a+a), Int(a+b+b), Int(b+a+b), Int(b+b+a), Int(b+b+b)]
	Case 16
		Aufgabe = text[16]
		Auswahl = [171, 252, 333, 414, 585, 666, 747, 828, 909, 999]
	Case 17
		Local b:Int, a:Int = Rand(2,5)
		If a = 2 Then b = Rand(7,9)
		If a = 3 Then b = 5
		If a = 4 Then b = 4
		If a = 5 Then b = 3
		Local c:Int = Rand(121, 987)
		Aufgabe = text[17] + a + "^" + c + " durch " + a + "^" + (c-b) + " und addiere eine Zufallszahl zwischen -3 und +3."
		Losung = a^b
		Auswahl = [Losung-3, Losung-2, Losung-1, Losung, Losung+1, Losung+2, Losung+3]
	Case 18
		Losung = Rand(19,20)
		Aufgabe = text[18] + Losung + " und dann noch eine Zufallszahl zwischen -3 und +3."
		Losung = Losung*(Losung+1)/2
		Auswahl = [Losung-3, Losung-2, Losung-1, Losung, Losung+1, Losung+2, Losung+3]
	Case 19
		Aufgabe = text[19]
		Auswahl = [100, 121, 144, 169, 196, 225, 256, 289, 324, 361]
	Case 20
		Aufgabe = text[20]
		Auswahl = [125, 216, 343, 512, 729]
	Case 21
		Aufgabe = text[21]
		Auswahl = [111, 133, 313, 155, 515, 177, 717, 199, 919, 339]
	Case 22
		Aufgabe = text[22]
		Auswahl = [212, 422, 632, 842, 414, 824]
	Case 23
		Aufgabe = text[23]
		Auswahl = [117, 119, 121, 123, 129, 133, 141, 143, 147, 153, 159]
	Case 24
		Aufgabe = text[24]
		Auswahl = [333, 353, 373, 535, 555, 575, 737, 757, 777]		
	End Select
	Losung = Auswahl[Rand(0,Len(Auswahl)-1)]
	'=================================================
	Nr = Nr + 1
	Ziffer = [-1,-1,-1]
	AktuelleZiffernPosition = 0
End Function
'-------------------------------------------------
Function zeige_Aufgabe()
	'SetColor 200,200,200
	DrawText Aufgabe, 20, 15
	'SetColor 255,255,255
End Function
Global korrekt:TSound = LoadSound("x/kr.ogg"), falsch:TSound = LoadSound("x/fl.ogg")
Function Codekontrolle:Byte()
	AktuelleZiffernPosition = 0
	If Losung = 100*Ziffer[0]+10*Ziffer[1]+Ziffer[2] Then
		PlaySound(korrekt)
		Return True
	Else
		PlaySound(falsch)
		Ziffer = [-1,-1,-1]
		AktuelleZiffernPosition = 0
	End If
End Function
'============   Digitalanzeige:   =====================
Global Ziffer:Int[], AktuelleZiffernPosition:Int, Digitalziffer:TImage = LoadAnimImage("x/DZ.png",70,100,0,10), Beep:TSound[10]
For Local b:Int = 0 To 9
	Beep[b] = LoadSound("x/b" + b + ".ogg")
Next
Function zeige_Digitalanzeige()
	If Ziffer[0] > -1 Then DrawImage Digitalziffer, 28, 46, Ziffer[0]
	If Ziffer[1] > -1 Then DrawImage Digitalziffer, 104, 46, Ziffer[1]
	If Ziffer[2] > -1 Then DrawImage Digitalziffer, 177, 46, Ziffer[2]
	For Local z:Int = 48 To 57
		If KeyHit(z) Then
			PlaySound(Beep[z-48])
			Ziffer[AktuelleZiffernPosition] = z - 48
			AktuelleZiffernPosition = (AktuelleZiffernPosition + 1) Mod 3
		End If		
	Next
	If KeyHit(KEY_BACKSPACE) Then
		AktuelleZiffernPosition = AktuelleZiffernPosition - 1
		If AktuelleZiffernPosition < 0 Then AktuelleZiffernPosition = 2
		Ziffer[AktuelleZiffernPosition] = -1
	End If	
End Function
'============   Zndschnur:   =========================
Global Schnur_Start:Int, KnotenAnzahl:Int = 599, Schnur_x%[KnotenAnzahl+1], Schnur_y%[KnotenAnzahl+1], Schnurknoten:TImage = LoadAnimImage("x/kn.png", 12,12,0,8), Explosion:TSound = LoadSound("x/ex.ogg"), Zischen:TSound = LoadSound("x/zs.ogg"), Zischen_Kanal:TChannel
Function zeige_Schnur:Byte()
	Local ActualTime% = MilliSecs()
	Local Stop:Int = KnotenAnzahl*(60000 - ActualTime + Schnur_Start) / 60000
	If Stop < 0 Then Return True
	SetColor 255,255,255
	For Local s:Int = 0 To Stop
		DrawImage Schnurknoten, Schnur_x[s], Schnur_y[s], s Mod 8
	Next
	SetAlpha 0.3
	SetColor 0,0,0
	For Local s:Int = Stop+1 To KnotenAnzahl
		DrawImage Schnurknoten, Schnur_x[s], Schnur_y[s], s Mod 8
	Next
	SetAlpha 1.0
	zeige_Funkenfeuer(Schnur_x[Stop], Schnur_y[Stop])
	If ChannelPlaying(Zischen_Kanal) = False Then Zischen_Kanal = PlaySound(Zischen)
	SetChannelPan(Zischen_Kanal, 0.5*(Schnur_x[Stop]-400)/400.0)
	SetColor 255,255,255
End Function
Function Schnur_neu_positionieren()
	Local file:TStream = ReadFile("x/SP")
	Schnur_x[0] = 527
	Schnur_y[0] = 151
	Local count:Int = 2
	While Not Eof(file)
		Schnur_x[count] = ReadInt(file)
		Schnur_y[count] = ReadInt(file)
		Schnur_x[count-1] = (Schnur_x[count-2] + Schnur_x[count]) / 2
		Schnur_y[count-1] = (Schnur_y[count-2] + Schnur_y[count]) / 2
		count = count + 2
	Wend
	For Local Anzahl:Int = 0 To 99
		Local P:Funkenpartikel = New Funkenpartikel
		P.x = Schnur_x[599] + Rand(-3,3)
		P.y = Schnur_y[599] + Rand(-3,3)
		P.way = Rand(20,30)
		P.r = Rnd()*360
		P.start = MilliSecs()
		ListAddLast(Funkenpartikel_Liste, P)
		Schnur_Start = MilliSecs()
	Next
	CloseStream(file)
End Function
'============   Introschleife:   ======================
Global Anzahl_Richtig:Int, Richtig_Symbol:TImage = LoadImage("x/or.png")
Function Intro()
	Repeat
		DrawImage Empty_Background, 0,0
		For Local i:Int = 1 To Anzahl_Richtig
			Local Factor:Float = 1.0 * i / Anzahl_Richtig
			SetColor Factor*155 + 100, Factor*155 + 100, Factor*155 + 100
			SetScale 0.3 + 0.7 * Factor, 0.3 + 0.7 * Factor
			DrawImage Richtig_Symbol, i*(16 + 14*Factor), 160
		Next
		SetScale 2,3.5
		SetColor 160,160,160
		If Anzahl_Richtig = 25 Then
			Zittertext(text[25], 60)
			Zittertext(text[26], 300)
			Zittertext(text[27], 380)
			Zittertext(text[28], 460)			
		ElseIf Anzahl_Richtig > 1 Then
			Zittertext(text[29], 60)
			Zittertext(text[30] + Anzahl_Richtig + " Zahlen-Codes geknackt!", 300)
			Zittertext(text[31], 380)
			Zittertext(text[32], 460)
		ElseIf Anzahl_Richtig = 1 Then
			Zittertext(text[33], 60)
			Zittertext(text[34], 300)
			Zittertext(text[35], 380)
			Zittertext(text[36], 460)
		Else
			For Losung = 0 To 9
				Zittertext(text[37+Losung], 30 + Losung*55)
			Next
		End If
		SetScale 1,1
		SetColor 255,255,255
		SetAlpha 1
		If KeyHit(KEY_RETURN) Then
			If Anzahl_Richtig = 25 Then
				Anzahl_Richtig = 0
				Nr = 0
				AufgabenPermutation = BildeAufgabenPermutation(25)
			End If
			FlushKeys()
			Return
		End If
		Flip
		If KeyDown(KEY_ESCAPE) Or AppTerminate() = True Then End
		WaitTimer(GlobalTimer)
	Forever
End Function
'======================================================
Function Zittertext(tx:String, y:Int)
	SetAlpha 0.7 + 0.3*Rnd()
	DrawText tx, 60+Rand(0,1), y
End Function
'============   Spielschleife:   ======================
Function Spiel:Byte()
	Zischen_Kanal = PlaySound(Zischen)
	Repeat
		DrawImage Background, 0,0
		If zeige_Schnur() = True Then Return False
		zeige_Aufgabe()
		zeige_Digitalanzeige()
		If KeyHit(KEY_RETURN) Then
			If Codekontrolle()	= True Then
				Anzahl_Richtig = Anzahl_Richtig + 1
				Return True
			End If
		End If
		'--------------------------------------------------------------------
		Flip
		WaitTimer(GlobalTimer)
		If KeyDown(KEY_ESCAPE) Or AppTerminate() = True Then End
	Forever
End Function
'============   Hauptschleife:   ======================
Repeat
	Intro()
	ClearList(Funkenpartikel_Liste)
	Schnur_neu_positionieren()
	neue_Aufgabe()
	Local Erfolg:Byte = Spiel()
	StopChannel(Zischen_Kanal)
	ClearList(Funkenpartikel_Liste)
	If Erfolg = False Then
		PlaySound(Explosion)
		For Local i:Int = 0 To 10
			Graphics Rand(500,1000), Rand(400, 800)
			SetClsColor 255, Rand(0,255), 0
			Cls
			Flip
		Next
		EndGraphics
		Delay 999
		End
	End If
Forever
'======================================================